'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _ItemTitle = require('./ItemTitle.component');

var _ItemTitle2 = _interopRequireDefault(_ItemTitle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('ItemTitle', function () {
	it('should render text title', function () {
		// given
		var props = {
			id: 'title',
			value: 'Hello world'
		};

		// when
		var wrapper = _reactTestRenderer2.default.create(_react2.default.createElement(_ItemTitle2.default, props)).toJSON();

		// then
		expect(wrapper).toMatchSnapshot();
	});

	it('should render button title', function () {
		// given
		var props = {
			id: 'title',
			value: 'Hello world',
			display: 'button',
			onClick: jest.fn()
		};

		// when
		var wrapper = _reactTestRenderer2.default.create(_react2.default.createElement(_ItemTitle2.default, props)).toJSON();

		// then
		expect(wrapper).toMatchSnapshot();
	});

	it('should render input title', function () {
		// given
		var props = {
			id: 'title',
			value: 'Hello world',
			display: 'input',
			onChange: jest.fn(),
			onSubmit: jest.fn(),
			onCancel: jest.fn()
		};

		// when
		var wrapper = _reactTestRenderer2.default.create(_react2.default.createElement(_ItemTitle2.default, props)).toJSON();

		// then
		expect(wrapper).toMatchSnapshot();
	});
});